/*----- PROTECTED REGION ID(TestDynamic.DynamicEnumAttr.java) ENABLED START -----*/
//=============================================================================
//
// file :        DynamicEnumAttr.java
//
// description : Java source for the dynamic attribute DynamicEnumAttr.
//               this attribute belongs to the TestDynamic class.
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

/*----- PROTECTED REGION END -----*/	//	TestDynamic.DynamicEnumAttr.java

package org.tango.testdynamic;

import org.tango.DeviceState;
import org.tango.server.StateMachineBehavior;
import org.tango.server.attribute.IAttributeBehavior;
import org.tango.server.attribute.AttributeValue;
import org.tango.server.attribute.AttributeConfiguration;
import org.tango.server.attribute.AttributePropertiesImpl;

//	Import Tango IDL types
import fr.esrf.Tango.*;


/*----- PROTECTED REGION ID(TestDynamic.DynamicEnumAttr.addImports) ENABLED START -----*/

/*----- PROTECTED REGION END -----*/	//	TestDynamic.DynamicEnumAttr.addImports


/**
 * Dynamic attribute DynamicEnumAttr, DynamicEnumAttrEnum, Scalar, READ_WRITE
 * description:
 *     
 */
public class DynamicEnumAttr implements IAttributeBehavior {

	/**	The attribute name */
	private String  attributeName;

	/*----- PROTECTED REGION ID(TestDynamic.DynamicEnumAttr.dataMembers) ENABLED START -----*/
	
	//	Put your data member declarations
	private DynamicEnumAttrEnum readValue = DynamicEnumAttrEnum.ZERO;
	private DynamicEnumAttrEnum writeValue = DynamicEnumAttrEnum.ZERO;;
	/*----- PROTECTED REGION END -----*/	//	TestDynamic.DynamicEnumAttr.dataMembers

	/**
	 * Dynamic attribute DynamicEnumAttr constructor
	 * @param attributeName The dynamic attribute name
	 */
	public DynamicEnumAttr(String attributeName) {
		this.attributeName = attributeName;
	}

	/**
	 * Build and return the configuration for dynamic attribute DynamicEnumAttr.
	 * @return the configuration for dynamic attribute DynamicEnumAttr.
	 * @throws DevFailed in case of configuration error.
	 */
	@Override
	public AttributeConfiguration getConfiguration() throws DevFailed {
		AttributeConfiguration  config = new AttributeConfiguration();
		config.setName(attributeName);
		config.setType(DynamicEnumAttrEnum.class);
		config.setFormat(AttrDataFormat.SCALAR);
		config.setWritable(AttrWriteType.READ_WRITE);
		config.setDispLevel(DispLevel.OPERATOR);
	
		//	Set attribute properties
		AttributePropertiesImpl	properties = new AttributePropertiesImpl();
		config.setAttributeProperties(properties);
		return config;
	}

	/**
	 * Get dynamic attribute state machine
	 * @return the attribute state machine
	 * @throws DevFailed if the state machine computation failed.
	 */
	@Override
	public StateMachineBehavior getStateMachine() throws DevFailed {
		StateMachineBehavior stateMachine = new StateMachineBehavior();
		/*----- PROTECTED REGION ID(TestDynamic.DynamicEnumAttr.getStateMachine) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	TestDynamic.DynamicEnumAttr.getStateMachine
		return stateMachine;
	}

	/**
	 * Get dynamic attribute value
	 * @return the attribute value
	 * @throws DevFailed if the read value failed.
	 */
	@Override
	public AttributeValue getValue() throws DevFailed {
		DynamicEnumAttrEnum	readValue;
		/*----- PROTECTED REGION ID(TestDynamic.DynamicEnumAttr.getValue) ENABLED START -----*/
		this.readValue = this.writeValue;
		/*----- PROTECTED REGION END -----*/	//	TestDynamic.DynamicEnumAttr.getValue
		return new AttributeValue(this.readValue);
	}

	/**
	 * Set dynamic attribute value
	 * @param writeValue the attribute value
	 * @throws DevFailed if the set value failed.
	 */
	@Override
	public void setValue(AttributeValue writeValue) throws DevFailed {
		/*----- PROTECTED REGION ID(TestDynamic.DynamicEnumAttr.setValue) ENABLED START -----*/
		System.out.println("Writing " + writeValue + "to hardware");
		this.writeValue = (DynamicEnumAttrEnum) writeValue.getValue();
		/*----- PROTECTED REGION END -----*/	//	TestDynamic.DynamicEnumAttr.setValue
	}

	/*----- PROTECTED REGION ID(TestDynamic.DynamicEnumAttr.methods) ENABLED START -----*/
	
	//	Put your own methods
	
	/*----- PROTECTED REGION END -----*/	//	TestDynamic.DynamicEnumAttr.methods
}
